/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: prc_config.h 697 2007-12-25 04:43:57Z honda $
 */

/*
 *		ץå¸⥸塼SH12Aѡ
 *
 *  Υ󥯥롼ɥեϡtarget_config.hʤޤϡ饤
 *  롼ɤեˤΤߤ饤󥯥롼ɤ롥¾Υե뤫
 *  ľܥ󥯥롼ɤƤϤʤʤ
 */

#ifndef TOPPERS_PRC_CONFIG_H
#define TOPPERS_PRC_CONFIG_H

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ץåü̿Υ饤ؿ
 */
#include "prc_insn.h"

/*
 *  ȥ(start.S)
 */
extern void start(void);

/*
 *  ̤ϿγѤΥȥ
 */
extern void default_int_handler_entry(void);

/*
 *  󥿥ƥѤΥå
 */
#define TOPPERS_ISTKPT(istk, istksz) ((STK_T *)((char_t *)(istk) + (istksz)))

/*
 *  ƥȥ֥å
 */
typedef struct task_context_block {
	void	*sp;		/* åݥ */
	FP		pc;			/* ץ५ */
} CTXB;

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  ͥ٥ޥ饤֥
 *  
 *  SH12AǤϡơ쥸SRˤ47ӥåȤ4ӥåȤ˳ͥ
 *  ޥʥϡɥγͥ٥ޥIPMˤ֤Ƥ롥IPM
 *  ¸Ƥˡͥ٤γɽ-1Ϣ³͡ˤȤ
 *  ȤǽǤ뤬;פʺӥåȥեȤȿžɬפˤʤ롥
 *  򤱤뤿ˡIPM¸ˤϡSR47ӥåȤФ
 *  ȤȤˤ롥ͤͥ٥ޥɽȸƤӡIIPMȽ
 *  Ȥˤ롥
 */

/*
 *  ͥ٥ޥγɽɽѴ
 *
 *  ֥Υե뤫饤󥯥롼ɤΤˡCAST
 */
#define EXT_IPM(iipm)    (-CAST(PRI,(iipm) >> 4))       /* ɽɽ */
#define INT_IPM(ipm)     (CAST(uint32_t, -(ipm)) << 4)  /* ɽɽ */

#ifndef TOPPERS_MACRO_ONLY

/*
 *  IPMʥϡɥγͥ٥ޥɽˤθͤɽФ
 */
Inline uint32_t
current_iipm(void)
{
    return((uint32_t)(current_sr() & 0xF0U));
}

/*
 *  IPMʥϡɥγͥ٥ޥɽˤθͤ
 */
Inline void
set_iipm(uint32_t iipm)
{
    set_sr((current_sr() & ~0xF0U) | iipm);
}

/*
 *  TOPPERSɸ߽ǥμ¸
 *
 *  SH12Aϥơ쥸(SR)˳ͥ٥ޥ(IPM)äƤ롥
 *  CPUåե饰ǽʤΤᡤŪCPUå
 *  饰¸롥
 *
 *  ޤCPUå֤ѿ(lock_flag)Ѱդ롥
 *
 *  CPUåե饰ꥢƤ֤ϡIPMǥγͥ
 *  ޥͤꤹ롥δ֤ϡǥγͥ٥ޥϡ
 *  IPMѤ롥
 * 
 *  ФCPUåե饰åȤ줤֤ϡIPM򡤥ͥ
 *  ΤΤ٤Ƥγ׵ޥ(TIPM_LOCK)ȡ
 *  γͥ٥ޥȤι⤤ꤹ롥δ֤Υǥγ
 *  ͥ٥ޥϡΤѿ(saved_iipm, ɽݻ)
 *  դݻ롥
 *
 *  SH12AǤϡߤǳߤդǽ롥Τᡤ
 *  ߤνиǤϡ褬Ƚꤹɬפ롥ȽΤˤϡ
 *  åѤޤ줿SRIPM¹ԻΤIPMåɬפ
 *  롥¹ԻIPM saved_iipm ѤƼ뤿ᡤ
 *  ƥȤǤϡCPUåְʳǤϡsaved_iipm Ͼ
 *  IPMƱͤˤʤ褦ˤ롥
 */

/*
 *  ƥȻȤΤѿ
 */
extern uint32_t excnest_count; /* 㳰ʳ/CPU㳰ˤΥͥȲΥ */

/*
 *  ƥȤλ
 *
 *  SH12AǤϡƥȤȽˡ/CPU㳰ΥͥȲ
 * 
 */
Inline bool_t
sense_context(void)
{
    return(excnest_count > 0U);
}

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  CPUå֤Ǥγͥ٥ޥ
 *
 *  TIPM_LOCKϡCPUå֤Ǥγͥ٥ޥʤ
 *  ΤΤ٤Ƥγߤޥͤ롥
 */
#define TIPM_LOCK    TMIN_INTPRI

/*
 *  CPUå֤Ǥγͥ٥ޥɽ
 */
#define IIPM_LOCK    INT_IPM(TIPM_LOCK)

/*
 *  TIPM_ENAALLʳͥ٥ޥˤɽ
 */
#define IIPM_ENAALL  INT_IPM(TIPM_ENAALL)

#ifndef TOPPERS_MACRO_ONLY

/*
 *  CPUåե饰¸Τѿ
 * 
 *  ѿϡCPUå֤λΤ߽񤭴Ƥ褤Ȥ롥
 *  饤ؿǡνѲʤ褦volatile ꡥ 
 */
extern volatile bool_t   lock_flag;   /* CPUåե饰ͤݻѿ */
extern volatile uint32_t saved_iipm;  /* ͥ٤ޥѿ */

/*
 *  CPUå֤ؤΰܹ
 *
 *  IPMʥϡɥγͥ٥ޥˤsaved_iipm¸
 *  ͥΤΤ٤Ƥγߤޥ͡TIPM_LOCKˤ
 *  ꤹ롥ޤlock_flagtrueˤ롥
 *
 *  IPMǽ餫TIPM_LOCKƱ⤤ˤϡ
 *  saved_iipm¸ΤߤǡTIPM_LOCKˤꤷʤϡǥ
 *  γͥ٥ޥTIPM_LOCKƱ⤤٥
 *  Ƥ֤ˤ롥
 *
 *  δؿϡCPUå֡lock_flagtrueξ֡ˤǸƤФ뤳Ȥ
 *  ʤΤꤷƤ롥
 */
Inline void
x_lock_cpu(void)
{
    uint32_t iipm;

    /*
     *  current_iipm()֤ͤľsaved_iipm¸ѿiipm
     *  ѤƤΤϡcurrent_iipm()Ƥľ˳ߤȯ
     *  ư줿߽saved_iipmѹǽ뤿
     *  롥
     */
    iipm = current_iipm();
    if (IIPM_LOCK > iipm) {
        set_iipm(IIPM_LOCK);
    }
    saved_iipm = iipm;    
    lock_flag = true;
    /* ƥ륻ǥ꤬񤭴ǽ */
    Asm("":::"memory");
}

#define t_lock_cpu()    x_lock_cpu()
#define i_lock_cpu()    x_lock_cpu()

/*
 *  CPUå֤β
 *
 *  lock_flagfalseˤIPMʥϡɥγͥ٥ޥˤ
 *  saved_iipm¸᤹ͤ
 *
 *  δؿϡCPUå֡lock_flagtrueξ֡ˤǤΤ߸ƤФ
 *  ΤꤷƤ롥
 */
Inline void
x_unlock_cpu(void)
{
    /* ƥ륻ǥ꤬񤭴ǽ */
    Asm("":::"memory");
    lock_flag = false;
    set_iipm(saved_iipm);
}

#define t_unlock_cpu()    x_unlock_cpu()
#define i_unlock_cpu()    x_unlock_cpu()

/*
 *  CPUå֤λ
 */
Inline bool_t
x_sense_lock(void)
{
    return(lock_flag);
}

#define t_sense_lock()    x_sense_lock()
#define i_sense_lock()    x_sense_lock()

/*
 *  chg_ipmͭʳͥ٤ϰϤȽ
 *
 *  TMIN_INTPRIͤˤ餺chg_ipmǤϡ-15TIPM_ENAALLʡ0ˤϰ
 *  Ǥ뤳ȤȤʥåγĥˡ
 */
#define VALID_INTPRI_CHGIPM(intpri) \
				((-15 <= (intpri) && (intpri) <= TIPM_ENAALL))

/*
 * ʥǥΡ˳ͥ٥ޥ
 *
 *  CPUåե饰ꥢƤϡϡɥγͥ٥
 *  ꤹ롥
 *  
 *  CPUåե饰åȤƤϡϡɥγͥ٥
 *  ꤷ褦ȤʥǥΡ˳ͥ٥ޥTIPM_LOCK
 *  ι⤤ꤹ롥
 *
 */
Inline void
x_set_ipm(PRI intpri)
{
    uint32_t   iipm = INT_IPM(intpri);

    
    if (!lock_flag) {
        set_iipm(iipm);
    }
    else {
        saved_iipm = iipm;
#if TIPM_LOCK == -15
        /*
         *  TIPM_LOCK-15ξˤϡλǥϡɥγͥ
         *  ٥ޥɬ15ꤵƤ뤿ᡤꤷʤɬפʤ
         */
#else /* TIPM_LOCK == -15 */
        set_iipm(iipm > IIPM_LOCK ? iipm : IIPM_LOCK);
#endif /* TIPM_LOCK == -15 */
    }
}

#define t_set_ipm(intpri)    x_set_ipm(intpri)
#define i_set_ipm(intpri)    x_set_ipm(intpri)

/*
 * ʥǥΡ˳ͥ٥ޥλ
 *
 *  CPUåե饰ꥢƤϥϡɥγͥ٥
 *  򡤥åȤƤsaved_iipm򻲾Ȥ롥
 */
Inline PRI
x_get_ipm(void)
{
    uint32_t iipm;

    if (!lock_flag) {
        iipm = current_iipm();
    }
    else {
        iipm = saved_iipm;
    }
    return(EXT_IPM(iipm));
}

#define t_get_ipm()    x_get_ipm()
#define i_get_ipm()    x_get_ipm()

/*
 *  ǹ̥ͥؤΥǥѥåprc_support.S
 *
 *  dispatchϡƥȤƤӽФ줿ӥ
 *  ƤӽФ٤ΤǡƥȡCPUå֡ǥѥ
 *  ľ֡ʥǥΡ˳ͥ٥ޥ֤ǸƤӽФ
 *  Фʤʤ
 */
extern void dispatch(void);

/*
 *  ǥѥåưϡprc_support.S
 *
 *  start_dispatchϡͥ뵯ư˸ƤӽФ٤Τǡ٤Ƥγ
 *  ߤػߤ֡ߥå֤Ʊξ֡ˤǸƤӽФʤ
 *  ʤʤ
 */
extern void start_dispatch(void) NoReturn;

/*
 *  ߤΥƥȤΤƤƥǥѥåprc_support.S
 *
 *  exit_and_dispatchϡext_tskƤӽФ٤Τǡƥ
 *  ȡCPUå֡ǥѥåľ֡ʥǥΡ˳ͥ
 *  ٥ޥ֤ǸƤӽФʤФʤʤ
 */
extern void exit_and_dispatch(void) NoReturn;

/*
 *  ͥνλθƽФprc_support.S
 *
 *  call_exit_kernelϡͥνλ˸ƤӽФ٤Τǡ󥿥
 *  ƥȤڤ괹ơͥνλexit_kernelˤƤӽ
 *  
 */
extern void call_exit_kernel(void) NoReturn;

/*
 *  ƥȤν
 *
 *  ٻ߾֤¹ԤǤ֤˰ܹԤ˸ƤФ롥λ
 *  ǥåΰȤäƤϤʤʤ
 *
 *  activate_context򡤥饤ؿǤϤʤޥȤƤΤϡ
 *  λǤTCBƤʤǤ롥
 */
extern void    start_r(void);

#define activate_context(p_tcb)                                         \
{                                                                       \
    (p_tcb)->tskctxb.sp = (void *)((char_t *)((p_tcb)->p_tinib->stk)      \
                                        + (p_tcb)->p_tinib->stksz);     \
    (p_tcb)->tskctxb.pc = (FP)start_r;                                  \
}

/*
 *  calltexϻѤʤ
 */
#define OMIT_CALLTEX

/*
 * å¸˴ޤޤɸ㳰ǽνѤʤ
 */
#define OMIT_INITIALIZE_EXCEPTION

/*
 * CPU㳰ϥɥν
 */
Inline void
initialize_exception(void)
{
}
     
/*
 *  SH12Aγߥƥȳ߽ǥμ¸
 * 
 *  SH12Aγߤϡե⥸塼ߡIRQߤʬǤ
 *  찷ۤʤ롥Τᡤߥϥɥֹ椫顤ɤγߤʬ
 *  뤿ΥޥѰդ롥
 */
     
/*
 *  ͥ
 *
 *  Ƴߤγͥ٤ϳͥ쥸(IPRXX)ˤä
 *  ꤹ롥ե⥸塼ξ硤ե⥸塼ǽǤ롥
 *  㤨SCIFϡERI2, RXI2, BRI2, TXI2Ȥ4Ĥγ׵饤
 *  ݡȤ뤬Ƥγ׵饤ФƱͥ٤
 *  ʤΤᡤƳ׵饤ˤɤγͥ쥸
 *  ꤹ뤫ơ֥Ѱդ롥ޤֹϢ³
 *  ƤʤᡤݡȤƤʤֹˤϡnumber-1ꤹ롥
 */

/*
 *  ƳֹꤹIPRξΤι¤  
 *  
 *  offset8ӥåȤнʬͳ32ӥåȤˤƤ롣
 *  ι¤Τˤȷ֤Ǥǡˤʤʤ
 *  SHǤ32ӥåȥǡǤʤ̵̤̿᤬롣
 */
typedef struct {
    /* ͥ쥸Υɥ쥹 */
    uint32_t address; 
    /* եå */
    uint32_t  offset;
} IPR_INFO;

/*
 *  ƳֹIPRξơ֥
 */
extern const IPR_INFO ipr_info_tbl[TNUM_INH];
    
/*
 *  ֹ桦ߥϥɥֹ
 *
 *  ߥϥɥֹ(inhno)ȳֹ(intno)ϡ٥ֹѤ롥
 *
 *  ٥ֹ64Ϥޤ뤿ᡤΤޤޤͤͥٴΥơ֥
 *  ǥåѤȡ̵̤ΰ褬ȯ롥Τᡤͥ
 *  Ǥϡ-64ͤѤ롥
 *
 *  ɽ̾ϡiintno,iinhnoȤ롥
 */

/*
 * ߥϥɥֹɽѴ
 */
#define EXT_INHNO(iintno) (CAST(uint32_t, (iinhno) + 64)) /* ɽɽ */
#define INT_INHNO(intno)  (CAST(uint32_t, (inhno) - 64))  /* ɽɽ */

/*
 * ֹɽѴ
 */
#define EXT_INTNO(iintno)   (CAST(uint32_t, (iintno) + 64)) /* ɽɽ */
#define INT_INTNO(intno)    (CAST(uint32_t, (intno) - 64))  /* ɽɽ */


/*
 *  ֹϰϤȽ
 * 
 *  TMIN_INTNOTMAX_INTNOϰϤǤäƤֹͭǤʤ礬뤿
 *  ᡤipr_info_tbl[]ֹͭ椫å
 */
#define VALID_INTNO(intno) \
        ((TMIN_INTNO <= (intno)) && ((intno) <= TMAX_INTNO) && (ipr_info_tbl[INT_INTNO(intno)].address != 0U))
#define VALID_INTNO_DISINT(intno)    VALID_INTNO(intno)
#define VALID_INTNO_CFGINT(intno)    VALID_INTNO(intno)

/*
 *  CPU㳰ϥɥֹ
 *
 *  CPU㳰ϥɥֹȤƤϡ٥ֹѤ롥
 *  ݡȤCPU㳰ϥɥϥץåη˰ۤʤΤǡץ
 *  åηե롥
 *
 */
#define VALID_EXCNO_DEFEXC(excno) \
        ((TMIN_EXCNO <= (excno)) && ((excno) <= TMAX_EXCNO))

/*
 *  ߥϥɥ
 *
 *  ٥ȥֹinhnoγߥϥɥεưint_entryꤹ롥
 *  ϥɥơ֥
 */
Inline void
x_define_inh(INHNO inhno, FP int_entry)
{
}

/*
 *  ߥϥɥνޥ
 *
 */
#define _INT_ENTRY(inhno, inthdr)    _kernel_##inthdr##_##inhno
#define INT_ENTRY(inhno, inthdr)     _INT_ENTRY(inhno, inthdr)

#define _INTHDR_ENTRY(inhno, inthdr) extern void _kernel_##inthdr##_##inhno(void);
#define INTHDR_ENTRY(inhno, inhno_num, inthdr)  _INTHDR_ENTRY(inhno, inthdr) 

/*
 *  ׵ػߥե饰
 *
 *  SH12AIRCϳ׵ػߥե饰ʤߤػߤϡ
 *  ͥ쥸(IPRXX)0ꤹɬפ롥ͥ
 *  쥸0ˤ뤳Ȥǳ׵ػߥե饰¸Ȥ
 *  ֡ͥ٤򵭲Ƥΰ褬ɬפȤʤ롥ե졼
 *  ǤΥơ֥Ѱդ롥ޤMSBˤϡγߤDEF_INH
 *  Ƥʤ"1"åȤ롥
 */
extern const uint8_t int_iipm_tbl[TNUM_INT];

/*
 *  ׵ػߥե饰Υå
 *
 *  ͥ쥸(IPRAG)0ꤹ롥
 *
 *  °ꤵƤʤ׵饤ФƳ׵ػ
 *  ե饰򥯥ꥢ褦Ȥˤϡfalse֤
 */
Inline bool_t
x_disable_int(INTNO intno)
{
    uint32_t iintno  = INT_INTNO(intno);
    uint32_t address = ipr_info_tbl[iintno].address;
    uint32_t offset  = ipr_info_tbl[iintno].offset;
    uint32_t iipm    = int_iipm_tbl[iintno];

	/*
	 *  °ꤵƤʤ
	 */
	if ((iipm & 0x80U) != 0) {
		return(false);
	}
    
    /* 
     *  ֹбIPRͤ0ˤ롥
     */
    set_irc_ipr(address, offset, 0x00);

    return(true);
}

#define t_disable_int(intno) x_disable_int(intno)
#define i_disable_int(intno) x_disable_int(intno)

/*
 *  ׵ػߥե饰β
 *
 *  ͥ쥸(IPRAG)򸵤᤹ͤ
 *
 *  °ꤵƤʤ׵饤ФƳ׵ػ
 *  ե饰򥯥ꥢ褦Ȥˤϡfalse֤
 */
Inline bool_t
x_enable_int(INTNO intno)
{
    uint32_t iintno  = INT_INTNO(intno);
    uint32_t address = ipr_info_tbl[iintno].address;
    uint32_t offset  = ipr_info_tbl[iintno].offset;
    uint32_t iipm    = int_iipm_tbl[iintno];

	/*
	 *  °ꤵƤʤ
	 */
	if ((iipm & 0x80U) != 0) {
		return(false);
	}

    /* 
     *  ֹбIPRͤ򥻥åȤ
     */
    set_irc_ipr(address, offset, (iipm & 0x0FU));
    
    return(true);
}

#define t_enable_int(intno) x_enable_int(intno)
#define i_enable_int(intno) x_enable_int(intno)

/*
 *  ׵饤°
 *
 *  SH34Ǥϡͥǰͥ٤16ʳǤ뤿ᡤintpri
 *  ȤͿ뤳ȤǤͤ-15-1ɸǤ롥
 */
extern void    x_config_int(INTNO intno, ATR intatr, PRI intpri);

/*
 *  ߥϥɥɬפIRC
 *
 *  IRQߤǤĥåȥꥬξϳ׵򥯥ꥢ롥
 *  åȥꥬȽǤΤݤʤΤǡ˥ꥢ롥
 */
Inline void
i_begin_int(INTNO intno)
{
    uint32_t dummy;
    if (INTNO_IRQ(intno)) {
        i_lock_cpu();
        /* ɤ߹ */
        dummy = sil_reh_mem((void *)IRQRR);
        sil_wrh_mem((void *)IRQRR, dummy & ~(0x01U << INTNO_TO_IRQNO(intno)));
        i_unlock_cpu();
    }
}

/*
 *  ߥϥɥνиɬפIRC
 */
Inline void
i_end_int(INTNO intno)
{
}
#endif /* TOPPERS_MACRO_ONLY */

/*
 *  CPU㳰ϥɥط
 */

/*
 *  㳰ϥɥ p_excinf ƼФΥޥ
 */
#define P_EXCINF_OFFSET_VECTOR UINT_C( 0)
#define P_EXCINF_OFFSET_PR     UINT_C( 1)
#define P_EXCINF_OFFSET_SR     UINT_C(13)
#define P_EXCINF_OFFSET_PC     UINT_C(12)

#define P_EXCINF_OFFSET_R0     UINT_C( 4)

#ifndef TOPPERS_MACRO_ONLY
/*
 *  CPU㳰ϥɥ
 */
Inline void
x_define_exc(EXCNO excno, FP exc_entry)
{       
}

/*
 *  CPU㳰ϥɥޥ
 */
#define EXC_ENTRY2(excno, exchdr)    _kernel_##exchdr##_##excno
#define EXC_ENTRY(excno, exchdr)     EXC_ENTRY2(excno, exchdr)
#define EXCHDR_ENTRY2(excno, exchdr) extern void _kernel_##exchdr##_##excno(void *sp);
#define EXCHDR_ENTRY(excno, excno_num, exchdr)  EXCHDR_ENTRY2(excno, exchdr)

/*
 *  CPU㳰ȯΥƥȤλ
 *
 *  CPU㳰ȯΥƥȤƥȤλfalse
 *  Ǥʤtrue֤
 */
Inline bool_t
exc_sense_context(void *p_excinf)
{
    return(excnest_count > 1U);
}

/*
 *  CPU㳰ȯIPMʥϡɥγͥ٥ޥɽ
 *  ˤλ
 */
Inline uint32_t
exc_get_iipm(void *p_excinf)
{
    return(*(((uint32_t *) p_excinf) + P_EXCINF_OFFSET_SR) & 0x00F0U);
}

/*
 *  CPU㳰ȯΥƥȤȳߤΥޥ֤λ
 *
 *  CPU㳰ȯΥƥ֤ͥ¹Ǥʤ
 *  ƥȤǤꡤߥå֤ǤʤCPUå֤Ǥʤʥ
 *  ǥΡ˳ͥ٥ޥ֤ǤtrueǤʤ
 *  false֤CPU㳰ͥγ߽ȯ
 *  ˤfalse֤ˡ
 *
 *  SHǤϡCPU㳰ȯIPMʥϡɥγͥ٥ޥ
 *  ٤ƤγߤĤ֤Ǥ뤳Ȥå뤳Ȥǡ
 *  ͥ¹Ǥʤȡߥå֤ǤʤȡCPUå֤Ǥ
 *  ȡʥǥΡ˳ͥ٥ޥ֤Ǥ뤳Ȥ4Ĥ
 *  å뤳ȤǤCPU㳰ȯlock_flag
 *  ȤɬפϤʤˡ
 */
Inline bool_t
exc_sense_intmask(void *p_excinf)
{
    return(!exc_sense_context(p_excinf)
                    && (exc_get_iipm(p_excinf) == IIPM_ENAALL));
}

/*
 *  CPU㳰ȯΥƥȤȳߡCPUå֤λ
 *
 *  CPU㳰ȯΥƥ֤ͥ¹Ǥʤ
 *  ƥȤǤꡤߥå֤ǤʤCPUå֤Ǥʤ
 *  trueǤʤfalse֤CPU㳰ͥγ߽
 *  ȯˤfalse֤ˡ
 *
 *  SH12ǤϡCPU㳰ȯIPMʥϡɥγͥ٥
 *  ˤTIPM_LOCK㤤Ȥå뤳Ȥǡͥ¹
 *  ʤȡߥå֤ǤʤȡCPUå֤ǤʤȤ3
 *  ξåƤCPU㳰ȯlock_flagϻȤ
 *  ʤˡˤꡤʥǥΡ˳ͥ٥ޥTIPM_LOCK
 *  ꤷƥ¹ԤƤˤfalse֤äƤޤȽǤ
 *  Τˤ뤿ΥХإåɤ礭Ȥ顤Ƥ뤳Ȥˤ롥
 */
Inline bool_t
exc_sense_unlock(void *p_excinf)
{
    return(!exc_sense_context(p_excinf)
                    && exc_get_iipm(p_excinf) < IIPM_LOCK);
}

/*
 * Trapaʳ㳰ϿƤʤ㳰ȯȸƤӽФ
 */
extern void default_exc_handler(void *p_excinf);

/*
 * ̤Ͽγߤȯ˸ƤӽФ
 */
extern void default_int_handler(void *p_excinf);

/*
 *  ץå¸ν
 */
extern void prc_initialize(void);

/*
 *  ץå¸νλ
 */
extern void prc_terminate(void);

/*
 *  atexitνȥǥȥ饯μ¹
 */
Inline void
call_atexit(void)
{
    extern void    software_term_hook(void);
    void (*volatile fp)(void) = software_term_hook;

    /*
     *  software_term_hookؤΥݥ󥿤򡤰övolatileΤfp
     *  ƤȤΤϡ0ȤӤŬǺʤ褦ˤ뤿
     *  Ǥ롥
     */
    if (fp != 0) {
        (*fp)();
    }
}

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_PRC_CONFIG_H */
