/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2007      by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: prc_support.S 697 2007-12-25 04:43:57Z honda $
 */

/*
 *  ץå¸⥸塼 ֥SH12Aѡ
 */

#define TOPPERS_MACRO_ONLY
#define UINT_C(val)     (val)        /* uint_tޥ */
#define ULONG_C(val)    (val)        /* ulong_tޥ */
#define CAST(type, val) (val)        /* 㥹ȤԤޥ */

/*
 *  ֥ѤΥޥͭˤ
 */
#define TOPPERS_ASM_MACRO
#include "kernel_impl.h"
#include "offset.h"

/*
 *  
 *    0x80ʾˤʤĥ졢
 *    Ԥưˤʤʤ
 */
#if !((TCB_p_tinib < 0x80) && (TCB_texptn < 0x80) && (TCB_sp < 0x80))
#error  Check (TCB_p_tinib < 0x80) && (TCB_texptn < 0x80) && (TCB_sp < 0x80)
#endif


/*
 *  ѤǤ̿᥻å
 */
#ifdef SH1
#define TOPPERS_SUPPORT_SH1_CODE
#endif	/*  SH1  */

#ifdef SH2
#define TOPPERS_SUPPORT_SH1_CODE
#define TOPPERS_SUPPORT_SH2_CODE
#endif	/*  SH2  */

#ifdef SH2E
#define TOPPERS_SUPPORT_SH1_CODE
#define TOPPERS_SUPPORT_SH2_CODE
#define TOPPERS_SUPPORT_SH2E_CODE
#endif	/*  SH2E  */

#ifdef SH2A
#define TOPPERS_SUPPORT_SH1_CODE
#define TOPPERS_SUPPORT_SH2_CODE
#define TOPPERS_SUPPORT_SH2E_CODE
#define TOPPERS_SUPPORT_SH2A_CODE
#endif	/*  SH2A  */


/*
 *  ͥǤγ߶ػ߻IMP
 *
 *  kernel_cfg.c Υ֥ǻ
 */
    .global _asm_mask_ipm
_asm_mask_ipm = INT_IPM(TMIN_INTPRI)

/*
 *  ǥѥå
 *
 *  Υ롼ϡ
 *   ƥ(excnest_count = 0)
 *   CPUå
 *   ǥѥåľ
 *   ʥǥΡ˳ͥ٥ޥ
 *  ǸƤӽФ롥
 */

    .text
    .align 2
    .global _dispatch
_dispatch:
    /* 
     *  pr,r8r14򥹥å¸
     *  r0r7ϸƤӽФ¸Ƥ뤿¸ɬפ̵
     */ 
#ifdef USE_BANKED_REG
    movmu.l r8,@-r15 
#else
    sts.l  pr, @-r15
    mov.l  r14,@-r15
    mov.l  r13,@-r15
    mov.l  r12,@-r15
    mov.l  r11,@-r15
    mov.l  r10,@-r15
    mov.l  r9, @-r15
    mov.l  r8, @-r15
#endif /* USE_BANKED_REG */
    mov.l  _p_runtsk_dis,r2  /* r0 <- p_runtsk                         */
    mov.l  @r2,r0
    mov.l  r15,@(TCB_sp,r0)  /* åTCB¸ 60ʲʤOK */
    mov.l  _dispatch_r_dis,r1/* ¹ԺƳϤ¸                     */
    bra    _dispatcher
     mov.l  r1,@(TCB_pc,r0)   /* ¹ԺƳϤTCB¸  60ʲʤOK  */
    /* 
     *  ǥ󥰥롼
     *   ǥȤٱ䥹åȤɽ
     *   ̿ᡧjmp, bra, jsr, bsr, bt/s, bf/s
     */ 

_dispatch_r:
    /*
     *  pr,r8r14򥹥å
     */    
#ifdef USE_BANKED_REG
    movmu.l @r15+,r8         
#else
    mov.l  @r15+,r8          /* 쥸                       */
    mov.l  @r15+,r9
    mov.l  @r15+,r10
    mov.l  @r15+,r11
    mov.l  @r15+,r12
    mov.l  @r15+,r13
    mov.l  @r15+,r14
    lds.l  @r15+,pr    
#endif /* USE_BANKED_REG */
    /*
     *  㳰롼εư
     *  dispatch_rdispatcherƤӽФ뤿ᡤ
     *  tcbΥɥ쥹r0äƤ롥      
     */
#ifdef TOPPERS_SUPPORT_SH2A_CODE
    bld.b  #TCB_enatex_bit, @(TCB_enatex,r0)
    bf/s   _dispatch_r_1        /* enatex  false ʤ꥿ */
     mov.l  @(TCB_texptn,r0),r1  /* texptn */
    tst    r1,r1
    bt     _dispatch_r_1        /* texptn  0̵ */
    mov.l  _call_texrtn_dis,r1  /* 㳰롼θƤӽФ */
    /* ٱ䥹åȤPCХʤΤǡbt/s̿ϻѤǤʤ */
    jmp    @r1
     nop
#else /* TOPPERS_SUPPORT_SH2A_CODE */
 	/*
 	 * SH2E
	 *bdl.b̿ʤ
	 *mov.b @(dips12, rn), rm̿ʤdisp0xfޤǡ
	 */
	mov	   #TCB_enatex, r1
	mov.b  @(r0, r1), r2
    mov    #TCB_enatex_mask,r3
    tst    r2, r3				/* tst #TCB_enatex_mask,r0ϥǥƥ͡r0 */
    bt     _dispatch_r_1		/* enatex  false ʤ꥿ */

    /* texptn  0̵С㳰롼θƤӽФ */
    mov.l  @(TCB_texptn,r0),r1  /* texptn */
    tst    r1,r1
    bt     _dispatch_r_1
    mov.l  _call_texrtn_dis,r1
    jmp    @r1
     nop
#endif /* TOPPERS_SUPPORT_SH2A_CODE */
_dispatch_r_1:
    rts
    nop

/*
 * ǥѥåưϡprc_support.S
 */
    .global _start_dispatch
_start_dispatch:
    /*
     *  Υ롼ϡͥ뵯ưˡ٤Ƥγߤػߤ
     * ߥå֤ƱˤǸƤӽФ롥ޤߥ⡼ɡ
     *  ƥȤƱˤǸƤӽФ뤳ȤꤷƤ롥
     *
     *  prc_initializeǡlock_flagtrueˡsaved_iipmIIPM_ENAALL
     *  Ƥ뤿ᡤͥγߤĤ뤳Ȥǡ
     *  CPUå֡ʥǥΡ˳ͥ٥ޥ֤ˤʤ롥
     *  ޤtask_initializedisdspfalse˽Ƥ뤿ᡤǥ
     *  ѥåľ֤ˤʤäƤ롥
     */
    mov.l  _excnest_count_dis, r1 /* excnest_count 0 */
    mov    #0,r0
    bra    _dispatcher_0
     mov.l  r0,@r1

/*
 *  ߤΥƥȤΤƤƥǥѥå
 */
    .globl _exit_and_dispatch
_exit_and_dispatch:
    /* ǥѥåΡdispatcherˤ */

/*
 * ǥѥå
 */
_dispatcher:
#ifdef LOG_DSP_ENTER
    mov.l _log_dsp_enter_dis, r1 /* ϴؿ */
    mov.l _p_runtsk_dis, r2      
    jsr   @r1
     mov.l  @r2, r4              /*          */
#endif /* LOG_DSP_ENTER */
_dispatcher_0:
   /*
    *  Υ롼ϡ
    *      ƥ
    *      CPUå
    *      ǥѥåľ
    *      ʥǥΡ˳ͥ٥ޥ
    *  ǸƤӽФ롥
    *
    *  ʤ
    *      excnest_count=0
    *      lock_flag=true
    *      disdsp=false
    *      dspflg=true
    *      saved_iipm=IIPM_ENAALL
    *ȤʤäƤ롥¹ԺƳϤؤ⤳ξ֤Τޤʬ롥
    */
    mov.l  _p_schedtsk_dis,r12  /* r0 <- p_schedtsk                 */
    mov.l  @r12,r0
    mov.l  _p_runtsk_dis,r2
    mov.l  r0,@r2               /* schedtskruntsk               */
    cmp/eq #0,r0                /* schedtsk 뤫              */
    bt     _dispatcher_1        /* ̵Х                 */
    mov.l  @(TCB_sp,r0),r15     /* TCB饿å      */
#ifdef LOG_DSP_LEAVE
    mov.l _log_dsp_leave_dis, r1 /* ϴؿ */
    mov   r0, r8                 /* r0ϥå쥸ʤΤ r8˥ԡ */
    jsr   @r1
     mov   r0, r4                /*       */
    mov  r8, r0                  /* r0TCBؤΥݥ󥿤᤹ */    
#endif /* LOG_DSP_LEAVE */
    mov.l  @(TCB_pc,r0),r1      /* TCB¹ԺƳϤ        */
    jmp    @r1
     nop

_dispatcher_1:
    /* ߥǥͤɤ߹ΤϸΨΤǻѰդ
     * r7  : excnest_count
     * r8  : ߶ػߤΤSR   
     * r9  : ԤSR
     * r10 : reqflg
     * r11 : 0x01
     * r12 : 0x00
     * r13 : sleepSRξ       
     * r14 : lock_flag
     */
    mov.l  _mask_ipm_dis,r8       /* ߶ػߤSR             */
    mov    #0,r9                  /* ԤSR           */
    mov.l  _kernel_istkpt_dis,r11
    mov.l  @r11,r15
    mov.l  _reqflg_dis,r10
    mov    #1,r11
    mov    #0,r12
    mov.l  _excnest_count_dis, r7 /* excnest_count 1ˤƳ߾֤ */
    mov.l  r11, @r7
    mov.l  _lock_flag_dis,r14
    mov.l  r12,@r14               /* CPUå֤ */
_dispatcher_2:        
    /*
     *  ǳߥ⡼ɤڤ괹Τϡȯ߽
     *  ˤɤΥåȤȤβȡߥϥɥ
     *  ΥǥѥåɻߤȤĤΰ̣롥
     *
     *ǥѥåνиǼ¹Ԥ٤ʤ(schedtsk==
     *NULL˾ϡsleep̿ˤäƥץåϥ⡼ɤ
     *ؤƳԤ򤷤Ƥ롣
     *
     *ߵĸsleep̿¹ԤƤ뤿ᡢߵ̿
     *¹˳׵᤬äƤʤ뤤ϳߵľ塢
     *sleep̿¹˳׵᤬äˡߵ̿
     *¹Ԥȶ˳ߤդ졢sleepޤޤ
     *ʤꡢreqflgΥå˿ʤޤʤ
     *1msec˥޳ߤ뤿ᡢºݤˤsleepޤޤ
     *ȤϤʤ
     *
     *ϡߤεĤsleep֤ؤΰܹԤȥߥå˼
     *ԤǤʤȤ˵롣
     *
     *  褹뤿ᡤRTEΡPC,SRٱ䥹åȤ̿
     *  ߤȤԲʬ˼¹ԤפȤͤѤߤεĤ
     *  ϥ⡼ɤؤΰܹԤԲʬ˹Ԥ
     */
#ifdef OMIT_POWER_CONTROL
    ldc    r9,sr               /* ߤε                   */
    nop
#else 
	mov.l r9, @-r15				/*  SRꤹͤ򥹥åѤ  */
	mov.l _sleep_end_dis, r6
	mov.l r6, @-r15				/*  Ϥ򥹥åѤ  */
	rte							/*  ߵĤʥåɤ߽ФͤSRꤹ*/
	sleep						/*  Ʊ˾ϥ⡼ɤذܹԤ롣ٱ䥹åȡ  */
_sleep_end:
#endif /* OMIT_POWER_CONTROL */          
    ldc    r8,sr               /* ߶ػ                     */
    mov.l  @r10,r6             /* r6 <- reqflg                     */
    tst    r6,r6               /* reqflg  falseʤ              */
    bt     _dispatcher_2       /* dispatcher_2                   */
    mov.l  r12,@r7              /* excnest_count 򥯥ꥢ           */
    mov.l  r12,@r10            /* reqflg  false                */
    /*
     *  CPUå֤᤹Ԥδ֤˼¹Ԥߥϥɥˤ
     *  ꡤsaved_iipm񤭴ǽ뤿ᡤ᤹ͤɬ
     *  פ롥dispatcher¹Ԥϡsaved_iipmIIPM_ENAALL
     *  ȤʤäƤ뤿ᡤǤsaved_iipmIIPM_ENAALLʡ0ˤ᤻
     *  Ф褤
     */
    mov.l  _saved_iipm_dis, r10
    mov.l  r11,@r14            /* CPUå֤ */
    bra    _dispatcher_0
     mov.l  r12,@r10            /* saved_iipm0ˤ */

    .align 4
_excnest_count_dis:
    .long _excnest_count;
_mask_ipm_dis:
    .long INT_IPM(TMIN_INTPRI)
_dispatch_r_dis:    
    .long _dispatch_r
_p_runtsk_dis:    
    .long _p_runtsk
_enatex_mask_dis:    
    .long TCB_enatex_mask
_call_texrtn_dis:    
    .long _call_texrtn
_p_schedtsk_dis:    
    .long _p_schedtsk
_kernel_istkpt_dis:
    .long __kernel_istkpt
_reqflg_dis:
    .long  _reqflg
_lock_flag_dis:
    .long _lock_flag
_saved_iipm_dis:
    .long _saved_iipm
_sleep_end_dis:
	.long _sleep_end
#ifdef LOG_DSP_ENTER
_log_dsp_enter_dis:
    .long _log_dsp_enter
#endif /* LOG_DSP_ENTER */
#ifdef LOG_DSP_LEAVE
_log_dsp_leave_dis:
    .long _log_dsp_leave
#endif /* LOG_DSP_LEAVE */

/*
 *  ͥνλθƽФ
 *
 *  ⡼ɤȥå󥿥ƥѤڤؤ
 */
    .globl _call_exit_kernel
_call_exit_kernel:
    mov.l _mask_ipm_exit,r0
    ldc   r0,sr    
    mov.l _kernel_istkpt_exit,r1
    mov.l _exit_kernel_exit,r0
    jmp   @r0
     mov.l @r1,r15

    .align 4
_mask_ipm_exit:    
    .long INT_IPM(TMIN_INTPRI)
_kernel_istkpt_exit:
    .long __kernel_istkpt
_exit_kernel_exit:
    .long _exit_kernel


/*
 *  ư
 *
 *  ǥѥå㤫ƤӽФ뤿ᡤTCBΥɥ쥹r0
 *  äƤ
 */ 
    .text
    .align 2
    .globl _start_r
_start_r:
    mov.l  _lock_flag_start, r1  /* CPUå֤ */
    xor    r2,r2 
    mov.l  r2,@r1
    ldc    r2,sr                 /* ߵ */
    mov.l  _ext_tsk_start,r2     /* Ϥ */
    lds    r2,pr 
    mov.l  @(TCB_p_tinib,r0),r3  /* p_runtsk->p_tinibr3  */
    mov.l  @(TINIB_task,r3),r1   /* ưϤr1     */
    jmp    @r1
     mov.l  @(TINIB_exinf,r3),r4  /* exinf쥸r4  */

    .align 4
_lock_flag_start:
    .long _lock_flag
_ext_tsk_start:
    .long _ext_tsk


/*
 *  ߤκݤΥåݥ󥿤ؤ֤SR,PCΥԡ
 *  ޤǤΥեå
 *
 *  Ǥåݥ󥿤ȤϳߡCPU㳰ǥץ
 *  쥸PR򤬽äḷ̌ͤ롣SRϥåƬ
 *  40ХȲˡPC36ХȲѤޤƤ롣
 */
#ifdef USE_BANKED_REG
#define    SP_SR_OFFSET_INT     (4)
#define    SP_PC_OFFSET_INT     (0)
#else /* USE_BANKED_REG  */
#define    SP_SR_OFFSET_INT    (40+8)
#define    SP_PC_OFFSET_INT    (36+8)
#endif /* USE_BANKED_REG */


/*
 *  ̳ߤ
 *  
 *r7߼ľSRΥԡ
 *r6C롼Ƭɥ쥹
 *r5ֹ
 *    r4¸Ѥ
 */
    .text
    .align 2
    .global _int_entry
_int_entry:
#ifndef  USE_BANKED_REG    
    mov.l  r3,@-r15   /*  ĤΥå쥸򥹥åѤ  */
    mov.l  r2,@-r15
    mov.l  r1,@-r15
    mov.l  r0,@-r15
    sts.l  mach,@-r15
    sts.l  macl,@-r15
    sts.l  pr,@-r15 
#endif /* USE_BANKED_REG */
    mov.l  _excnest_int, r0      /* /CPU㳰ͥȥ󥿤Υå */
    mov.l  @r0,r1
    tst    r1,r1                 /* ȯΥƥȤȽ  */
    add    #0x1,r1               /* ߥͥȥ󥿤򥤥󥯥 */
    mov.l  r1,@r0
    bf     _int_entry_1          /* ¿ųߤʤ饸  */
    mov    r15,r2                /* åؤΥåݥ  */
    mov.l  _kernel_istkpt_int,r3 /* 󥿤¸                          */
    mov.l  @r3,r15               
    mov.l  r2,@-r15              /* å¸ */
_int_entry_1:

    mov.l  r5,@-r15              /* ֹ¸ */
    ldc    r7,sr                 /* ߵ  */
#ifdef LOG_INH_ENTER
    mov.l  r6,@-r15              /* r6¸ */
    mov.l _log_inh_enter_int, r1 /* ϴؿ */
    jsr   @r1
    mov  r5, r4                /*           */
    mov.l @r15+, r6              /* r6        */    	
#endif /* LOG_INH_ENTER */
    jsr    @r6                   /* C롼ƤӽФ  */
     mov    r15, r4              /* default_int_handlerѤΰ */

#ifdef LOG_INH_LEAVE
    mov.l _log_inh_leave_int, r1 /* ϴؿ                        */
    jsr  @r1
    mov.l @r15+,r4             /* ֹ                    */
#else  /* LOG_INH_LEAVE */
    add   #4,r15				 /* ֹɤФ              */
#endif /* LOG_INH_LEAVE */

    /*
     * ߥϥɥи
     *
     * /CPU㳰ͥȥ󥿤ǥȤ褫ߤ
     * Ƚꤷƥåؤ롥
     * ͥγߤ򥵥ݡȤȤƤϡξԤδ֤˥ͥ
     * γߤ礬롥ͥγߤϡ
     * ͥγߤƱͤǤ뤿ᡤ/CPU㳰ͥȥ
     * 򻲾Ȥơåؤ롥Τᡤ/CPU㳰ͥ
     * 󥿤ȥåؤϥͥγߤФƤ⡤
     * Բʬ˹Ԥɬפ롥
     */
_ret_int:
    mov.l  _mask_ipm_max_int,r0  /*  ߡʥͥޤ˶ػ  */
    ldc    r0,sr                 

    mov.l  _excnest_int,r0       /* /CPU㳰ͥȥ󥿤ǥ */
    mov.l  @r0,r1
    add    #0xff, r1
    mov.l  r1,@r0
    tst    r1,r1                 /* 褬󥿥ƥȤʤ餹 */
    bf     _ret_int_1            /* ꥿                               */
    mov.l  @r15,r15              /* 褬ʤΤǥå᤹     */
    mov.l  _reqflg_int,r4        /* reqflgΥå */
    mov.l  @r4,r1
    tst    r1,r1                 /* reqflgfalseʤret_int_1              */
    bt     _ret_int_1
    mov.l  _mask_ipm_int,r0
    bra   _ret_int_2             /* ret_int_2ʬƥǥѥåʤ */
                                 /* Τreqflgϥꥢʤ            */
     ldc    r0,sr                 /* ͥγߤ              */

    /*
     *  ߽Υ꥿
     */
_ret_int_1:
    /*
     *  ߽Υ꥿ˤꡤCPUå֤˰ܹԤ褦
     *  롥ͥ٥ޥϡRTE̿ˤ긵ͤ뤿ᡤ
     *  lock_flagfalseˤƤФ褤lock_flagfalseˤΤϡ
     *  CPUå֤Τޤ޳ߥϥɥ餫äкˡ
     */
    mov.l _lock_flag_ret, r0
    xor   r1,r1
    mov.l  r1,@r0

_ret_int_1_1:
#ifdef USE_BANKED_REG
    resbank
#else
    lds.l  @r15+,pr
    lds.l  @r15+,macl
    lds.l  @r15+,mach
    mov.l  @r15+,r0
    mov.l  @r15+,r1
    mov.l  @r15+,r2
    mov.l  @r15+,r3
    mov.l  @r15+,r4
    mov.l  @r15+,r5
    mov.l  @r15+,r6
    mov.l  @r15+,r7
#endif /* USE_BANKED_REG */
    rte                
     nop

    .align 2
_kernel_istkpt_int:
    .long __kernel_istkpt
_excnest_int:                    /* ߡCPU㳰ͥȥ */
    .long  _excnest_count
_reqflg_int:
    .long  _reqflg
_mask_ipm_int:                   /* ͥ߶ػѥޥ */
    .long  INT_IPM(TMIN_INTPRI)  /* ipmʳΥӥåȤϥɤ */
_mask_ipm_max_int:               /* ػѥޥ */
    .long  INT_IPM(-15)
#ifdef LOG_INH_ENTER
_log_inh_enter_int:
    .long  _log_inh_enter
#endif /* LOG_INH_ENTER */
#ifdef LOG_INH_LEAVE
_log_inh_leave_int:
    .long  _log_inh_leave
#endif /* LOG_INH_LEAVE */

    /*
     *  ؤϳߥϥɥνиʬƤ
     *  
     *  褬reqflgåȤƤΤߤˤ롣
     */        
_ret_int_2:
    /*
     *褬ߤ⤷㳰ݤȽ
     *
     *SH12AǤ㳰/߼ľ˳߶ػߤˤʤäƤʤᡢ
     *  A̤γBǽ롣
     * ʤϥϡɥΥƥ򤱤褦ʤ˳ߥϥ
     *  ɥBǥڤؤ򵯤褦ʥӥƤ֤ȳB
     *νи̤Υ˥ǥѥåƤޤ2
     *ΥäƤޤǡAν٤Ƥޤ
     *ޤA٥ȥꥬ2󸡽ФƤޤ⤢롣
     *ɤᡢ/㳰ޤȤvector_entry
     *  ֤Υɥ쥹ϰϤʤǥѥå
     *  ꥿󤹤롥
     */
    mov.l  @(SP_PC_OFFSET_INT,r15),r0   /* r0 <-åѤޤ줿pc */
    mov.l  _vector_entry_start_ret, r1
    mov.l  _vector_entry_end_ret, r2
    cmp/hs r1, r0
    bf     _ret_int_2_1
    cmp/hs r0, r2
    bt     _ret_int_1_1

_ret_int_2_1:

    /*
     *  ǥѥåƤӽФ⤷ϥ㳰ƤӽФ
     */
    /*
     *  Х󥯥쥸Ѥϥå쥸
     *  å˳Ǽ
     */
#ifdef USE_BANKED_REG
    resbank
    movml.l  r7, @-r15
    sts.l    mach,@-r15
    sts.l    macl,@-r15    
    sts.l    pr,@-r15 
#endif /* USE_BANKED_REG */

    /*
     *  ǥѥåθƤӽФ
     *
     *  ؤϡCPU㳰ϥɥνиʬƤ롥
     *
     *  Ǥϡ褬Ǥꡤåϡå
     *  å쥸Τߤ¸줿֤ˤʤäƤ롥ޤ
     *  ͥγߤػߤ֤ȤʤäƤ롥
     */
_ret_int_3:
    /*  
     *reqflgΥꥢ
     *
     *ãreqflg򥯥ꥢƤޤȡ嵭γA
     *νиǥǥѥåƤӽФɬפʥǤǥ
     *ѥå㤬ƤӽФʤ
     *ʳBreqflg򥻥åȤơAreqflgѲʤ
     *
     */
    mov    #0x0, r0
    mov.l  _reqflg_ret,r1
    mov.l  r0, @r1        

    /*
     *  CPUå֤˰ܹԤ롥ͥγߤϤǤ˶ػߤ
     *  Τǡlock_flag򹹿롥
     *
     *  CPUå֤˰ܹԤ롥ͥγߤϤǤ˶ػߤ
     *  Τǡlock_flagsaved_iipm򹹿롥saved_iipmϡ
     *  γͥ٥ޥʤɽˤꤹ롥
     *
     *  λCPUå֤ȤΤϡdispatcherʬȡ
     *  call_texrtnƤӽФˡCPUå֤ˤʤäƤɬפ
     *  Ǥ롥
     */
    mov.l  _lock_flag_ret, r2    /* lock_flagtrue */
    mov    #0x01,r1
    mov.l  r1,@r2
    mov    r15,r0
    mov.l  @(12*4,r0),r2         /* IPMФ */
    mov    r2,r0
    and    #0xf0,r0              /* saved_iipm              */
    mov.l  _saved_iipm_ret, r1
    mov.l  r0,@r1

    /*
     *  dspflgfalseǤȡp_runtskp_schedtskƱˤϡ
     *  ǥѥåԤʤΥåɬפʤΤϡ㳰
     *  롼θƽФɬפʾˡǥѥåɬפʤƤ⡤
     *  reqflgtrueˤ뤿Ǥ롥
     */
    mov.l  _p_runtsk_ret,r1     /* r0 <- p_runtsk               */
    mov.l  @r1,r0           
    mov.l  _dspflg_ret,r2       /* dspflgfalseʤret_int_r_1 */
    mov.l  @r2,r3
    tst    r3,r3
    bt     _ret_int_r_1    
    mov.l  _p_schedtsk_ret,r4   /* r5 <- schedtsk                */ 
    mov.l  @r4,r5
    cmp/eq r0,r5                /* runtsk  schedtsk      */
    bt     _ret_int_r_1         /* Ʊʤret_int_r_1         */
#ifdef USE_BANKED_REG    
    lds.l  @r15+,pr             /* movmul  pr ѤΤ */
    movmu.l r8, @-r15           /* öåФ            */
#else
    mov.l  r14,@-r15            /* ĤΥ쥸¸          */
    mov.l  r13,@-r15                    
    mov.l  r12,@-r15                    
    mov.l  r11,@-r15                    
    mov.l  r10,@-r15                    
    mov.l  r9,@-r15                    
    mov.l  r8,@-r15
#endif /* USE_BANKED_REG */
    mov    #TCB_sp,r1           /* å¸           */
    mov.l  r15,@(r0,r1)    
    mov.l  _ret_int_r_ret,r1    /* ¹ԺƳϤ¸             */
    mov    #TCB_pc,r2    
    bra    _dispatcher
     mov.l  r1,@(r0,r2)  


_ret_int_r:
#ifdef USE_BANKED_REG    
    movmu.l @r15+,r8            /* åФ            */
    sts.l   pr,@-r15            /* prϥå˳Ǽľ      */
#else
    mov.l  @r15+,r8        
    mov.l  @r15+,r9        
    mov.l  @r15+,r10        
    mov.l  @r15+,r11        
    mov.l  @r15+,r12        
    mov.l  @r15+,r13        
    mov.l  @r15+,r14
#endif /* USE_BANKED_REG */
_ret_int_r_1:
    /*
     *  㳰롼εư
     *  ret_int_r  dispatcher ƤӽФ뤿ᡤtcbΥɥ쥹r0
     *  äƤ롥
     *  ʤߤνиǥåȯʤϥǥѥå
     *  ̤餺 ret_int ľ ret_int_1        
     */
#ifdef TOPPERS_SUPPORT_SH2A_CODE
    bld.b  #TCB_enatex_bit, @(TCB_enatex,r0)
    bf/s   _ret_int_r_2			/* enatex  false ʤret_int_r_2 */
     mov.l  @(TCB_texptn,r0),r1  /* texptn */
    tst    r1,r1
    bt     _ret_int_r_2         /* texptn  0ʤret_int_2 */
    mov.l _call_texrtn_ret,r1   /* 㳰롼θƤӽФ */
    /* ٱ䥹åȤPCХʤΤǡbt/s̿ϻѤǤʤ */
    jsr   @r1
     nop
#else /* TOPPERS_SUPPORT_SH2A_CODE */
 	/* SH2E */
	/* bdl.b̿ʤ */
	/* mov.b @(dips12, rn), r0̿ʤdisp0xfޤǡ */
	mov	   #TCB_enatex, r1
	mov.b  @(r0, r1), r2
    mov    #TCB_enatex_mask,r3
    tst    r2, r3				/* tst #TCB_enatex_mask,r0ϥǥƥ͡r0 */
    bt	   _ret_int_r_2			/* enatex  false ʤret_int_r_2 */
    							/* bt/s̿SH-2EʹߤǤʤȥݡȤʤ */
    mov.l  @(TCB_texptn,r0),r1  /* texptn */
    tst    r1,r1
    bt     _ret_int_r_2         /* texptn  0ʤret_int_2 */
    mov.l _call_texrtn_ret,r1   /* 㳰롼θƤӽФ */
    jsr   @r1
     nop
#endif	/* TOPPERS_SUPPORT_SH2A_CODE */

_ret_int_r_2:               
    mov.l  _lock_flag_ret, r2  /* lock_flagfalse */
    xor    r0,r0 
    mov.l  r0,@r2    
    lds.l  @r15+,pr
    lds.l  @r15+,macl
    lds.l  @r15+,mach
#ifdef USE_BANKED_REG    
    movml.l @r15+,r7    
#else
    mov.l  @r15+,r0
    mov.l  @r15+,r1
    mov.l  @r15+,r2
    mov.l  @r15+,r3
    mov.l  @r15+,r4
    mov.l  @r15+,r5
    mov.l  @r15+,r6
    mov.l  @r15+,r7
#endif /* USE_BANKED_REG */
    rte
     nop

    .align 4
_saved_iipm_ret:
    .long _saved_iipm
_reqflg_ret:
    .long _reqflg
_lock_flag_ret:
    .long  _lock_flag
_p_runtsk_ret:
    .long  _p_runtsk
_dspflg_ret:
    .long  _dspflg
_p_schedtsk_ret:
    .long  _p_schedtsk
_ret_int_r_ret:
    .long _ret_int_r
_enatex_mask_ret:    
    .long TCB_enatex_mask
_call_texrtn_ret:    
    .long _call_texrtn
_vector_entry_start_ret:
    .long __vector_entry_start
_vector_entry_end_ret:
    .long __vector_entry_end

/*
 *  CPU㳰
 *
 *  CPU㳰ϥɥϡ󥿥ƥȤǼ¹Ԥ롥ΤᡤCPU
 *  ϥɥƤӽФ˳ߥ⡼ɤ˰ܹԤ꥿󤷤Ƥ
 *  Υ⡼ɤ᤹Υ⡼ɤ᤹ˡߥ⡼ɤ˰ܹԤ
 *   SR ߥå¸롥CPU㳰ƥȤ
 *  ȯreqflg  true ˤʤäˡret_exc ʬ롥
 *  reqflg å˳ߤػߤʤȡreqflg å
 *  ˵ư줿ߥϥɥǥǥѥå׵ᤵ줿ˡǥ
 *  ѥåʤ
 *  
 *  ̿ξϤ2Хȿʤɬפ뤬
 *  бƤʤ
 *  
 *  CPU㳰װŸ롼r7,r6,r5¸
 *   r7  ߼ľSRΥԡ
 *   r6  C롼Ƭɥ쥹
 *   r5  ٥ֹ
 *  ξ֤Ǥ롣
 * 
 *        ----------------------
 *  0    |       㳰ֹ       |   <-- p_excinf
 *        ----------------------
 *  1    |         PR           |
 *        ----------------------
 *  2    |        MACH          |
 *        ----------------------
 *  3    |        MACL          |
 *        ----------------------
 *  4    |         R0           |
 *        ----------------------
 *  5    |         R1           |
 *        ----------------------
 *  6    |         R2           |
 *        ----------------------
 *  7    |         R3           |
 *        ----------------------
 *  8    |         R4           |
 *        ----------------------
 *  9    |         R5           |
 *        ----------------------
 * 10    |         R6           |
 *        ----------------------
 * 11    |         R7           |
 *        ----------------------
 * 12    |         PC           |   <-- sp_ret_exc_2λ
 *        ----------------------
 * 13    |         SR           |
 *        ----------------------
 */

/*
 *  㳰κݤΥåݥ󥿤ؤ֤SR,PCΥԡ
 *  ޤǤΥեå
 */
#define    SP_SR_OFFSET_EXC     4
#define    SP_PC_OFFSET_EXC     0

    .text
    .align 2
    .globl _exc_entry
_exc_entry:
    mov.l  r3,@-r15     /*  ĤΥå쥸򥹥åѤ  */
    mov.l  r2,@-r15
    mov.l  r1,@-r15
    mov.l  r0,@-r15
    sts.l  mach,@-r15
    sts.l  macl,@-r15
    sts.l  pr,@-r15 
    mov.l  r5,@-r15              /* 㳰ֹ¸  */
    mov    r15, r4               /* CPU㳰ϥɥؤΰ */    
    mov.l  _excnest_exc, r0      /* /CPU㳰ͥȥ󥿤Υå */
    mov.l  @r0,r1
    tst    r1,r1                 /* ȯΥƥȤȽ     */
    add    #0x1,r1               /* ߥͥȥ󥿤򥤥󥯥 */
    mov.l  r1,@r0
    bf     _exc_entry_1          /* ¿ųߤʤ饸               */
    mov    r15,r2                /* åؤΥåݥ   */
    mov.l  _kernel_istkpt_exc,r3 /* 󥿤¸                           */
    mov.l  @r3,r15               
    mov.l  r2,@-r15              /* å¸ */
_exc_entry_1:
    mov.l  _lock_flag_exc,r3     /*  lock_flag 򥹥å¸           */
    mov.l  @r3, r2
    mov.l  r2,@-r15
    mov.l  _saved_iipm_exc,r3    /*  saved_iipm 򥹥å¸          */
    mov.l  @r3, r2
    mov.l  r2,@-r15

    mov.l  r5,@-r15              /* 㳰ֹ¸ */
#ifdef LOG_EXC_ENTER
    mov.l  r7,@-r15              /* r7¸ */
    mov.l  r6,@-r15              /* r6¸ */
    mov.l _log_exc_enter_exc, r1 /* ϴؿ  */
    jsr   @r1
     mov  r5, r4                 /*           */
    mov.l @r15+, r6              /* r6        */    	
    mov.l @r15+, r7              /* r7        */
#endif /* LOG_EXC_ENTER */	

    jsr    @r6                   /* C롼ƤӽФ  */
     ldc    r7,sr                 /* ߵ  */

    /*
     * CPU㳰ϥɥи
     */
_ret_exc:
    mov.l  _mask_ipm_exc,r0      /* ߶ػ                          */
    ldc    r0,sr               

#ifdef LOG_EXC_LEAVE
    mov.l _log_exc_leave_exc, r1 /* ϴؿ                        */
    jsr  @r1
     mov.l @r15+, r4             /* CPU㳰װֹ               */
#else  /* LOG_EXC_LEAVE */
    add   #4,r15				 /* CPU㳰װֹɤФ          */
#endif /* LOG_EXC_LEAVE */

    mov.l  @r15+,r2            /* saved_iipm 򸵤᤹                     */
    mov.l  _saved_iipm_exc,r3  
    mov.l  r2,@r3
    mov.l  @r15+,r2            /* lock_flag 򸵤᤹                      */
    mov.l  _lock_flag_exc,r3   
    mov.l  r2,@r3
    mov    r15,r2              /* ȯͥγߤ˲ʤ褦 */
    mov.l  _excnest_exc,r0     /* /CPU㳰ͥȥ󥿤ǥ */
    mov.l  @r0,r1
    add    #0xff,r1
    mov.l  r1,@r0
    tst    r1,r1                 /* 褬󥿥ƥȤʤ餹 */
    bf     _ret_exc_1            /* ꥿                               */
    mov.l  @r2,r15                 /* 褬ʤΤǥå᤹     */
    mov.l  _reqflg_exc,r4        /* reqflgΥå */
    mov.l  @r4,r1
    tst    r1,r1                 /* reqflgtrueʤret_exc_2               */
    bf    _ret_exc_2             /* ret_exc_2ʬƥǥѥåʤ */
                                 /* Τreqflgϥꥢʤ            */
_ret_exc_1:
    mov.l  @r15+,r2              /* CPU㳰װֹ򥹥åФ      */
    lds.l  @r15+,pr				 /*  ׸Ƥ926ܤȽ֤äƤ롩  */
    lds.l  @r15+,macl
    lds.l  @r15+,mach
    mov.l  @r15+,r0
    mov.l  @r15+,r1
    mov.l  @r15+,r2
    mov.l  @r15+,r3
    mov.l  @r15+,r4
    mov.l  @r15+,r5
    mov.l  @r15+,r6
    mov.l  @r15+,r7
    rte
     nop

_ret_exc_2:
    /*
     *褬ߤݤȽ
     *  ܤret_int_2򻲾ȤΤ
     */    
    mov.l  @(SP_PC_OFFSET_EXC,r15),r0   /* r0 <-åѤޤ줿PC */
    mov.l  _vector_entry_start_exc, r1
    mov.l  _vector_entry_end_exc, r2
    cmp/hs r1, r0
    bf     _ret_exc_2_1
    cmp/hs r0, r2
    bt     _ret_exc_1

_ret_exc_2_1:
    bra    _ret_int_3
     mov.l  @r15+,r2              /* EXPEVT򥹥åФ */

    .align  4
_excnest_exc:                    /* /CPU㳰ͥȥ */
    .long  _excnest_count
_kernel_istkpt_exc:
    .long __kernel_istkpt
_lock_flag_exc:
    .long _lock_flag
_saved_iipm_exc:
    .long _saved_iipm
_mask_ipm_exc:
    .long INT_IPM(TMIN_INTPRI)
_reqflg_exc:
    .long  _reqflg
_vector_entry_start_exc:
    .long __vector_entry_start
_vector_entry_end_exc:
    .long __vector_entry_end
#ifdef LOG_EXC_ENTER
_log_exc_enter_exc:
    .long _log_exc_enter
#endif /* LOG_EXC_ENTER */	
#ifdef LOG_EXC_LEAVE
_log_exc_leave_exc:
    .long _log_exc_leave
#endif /* LOG_EXC_LEAVE */

/*
 *  ̤Ͽγߥϥɥ
 */
    .text
    .section .vector_entry,"xa"
    .global  _default_int_handler_entry
    .align 2
_default_int_handler_entry:
#ifndef USE_BANKED_REG    
    mov.l r7,@-r15                 /*  ɬ׺Ǿ¤Υ쥸򥹥å  */
    mov.l r6,@-r15                
    mov.l r5,@-r15
    mov.l r4,@-r15
#endif /* USE_BANKED_REG */   
    stc   sr,r7                    /* SR¸ */
    mov.l _mask_ipm_entry,r6       /* ߶ػ */
    ldc   r6,sr                                       
    mov.l _common_routine_entry,r5 /* ͭ */
    mov.l _c_routine_entry,r6      /* C롼Ƭɥ쥹 */
    /*  PCХɥ쥹ʤΤǡٱ䥹åȤˤʤ  */
    jmp   @r5
     nop

    .align 2
_mask_ipm_entry:
    .long __kernel_asm_mask_ipm
_c_routine_entry:
    .long _default_int_handler
_common_routine_entry:
    .long  _int_entry

/*
 *  Ԥ
 */
    .globl _sil_dly_nse
_sil_dly_nse:
    mov.l  _sil_dly_tim1, r1
    add    r1, r4
    cmp/pl r4
    bt     _sil_dly_nse1
    rts
     nop
_sil_dly_nse1:
    mov.l  _sil_dly_tim2, r1
    add    r1, r4
    cmp/pl r4
    bt     _sil_dly_nse1
    rts
     nop   

    .align 4
_sil_dly_tim1:
    .long  -SIL_DLY_TIM1
_sil_dly_tim2:
    .long  -SIL_DLY_TIM2
